unit Main;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ImgList, ActnList, Menus, ComCtrls, ExtCtrls, StdCtrls, ToolWin, Grids,
  DBTables, DBGrids;

type
  TwndMain = class(TForm)
    ActionList1: TActionList;
    acConnect: TAction;
    acDisconnect: TAction;
    ImageList1: TImageList;
    acNewPlanTable: TAction;
    MainMenu1: TMainMenu;
    Database1: TMenuItem;
    Connect1: TMenuItem;
    Disconnect1: TMenuItem;
    N1: TMenuItem;
    Newplantable1: TMenuItem;
    N2: TMenuItem;
    acExit: TAction;
    Exit1: TMenuItem;
    acSelectPlanTable: TAction;
    Selectplantable1: TMenuItem;
    RichEdit1: TRichEdit;
    Splitter1: TSplitter;
    ToolBar1: TToolBar;
    ToolButton1: TToolButton;
    ToolButton2: TToolButton;
    ToolButton3: TToolButton;
    ToolButton4: TToolButton;
    acAnalyse: TAction;
    Query1: TMenuItem;
    acAnalyse1: TMenuItem;
    ToolButton5: TToolButton;
    ToolButton6: TToolButton;
    StatusBar1: TStatusBar;
    acExecute: TAction;
    ToolButton7: TToolButton;
    Execute1: TMenuItem;
    Notebook1: TNotebook;
    TreeView1: TTreeView;
    DBGrid1: TDBGrid;
    Splitter2: TSplitter;
    ListView1: TListView;
    acAbout: TAction;
    Help1: TMenuItem;
    acAbout1: TMenuItem;
    acPrevious: TAction;
    acNext: TAction;
    N3: TMenuItem;
    Previous1: TMenuItem;
    Next1: TMenuItem;
    acStart: TAction;
    acRollback: TAction;
    Transaction1: TMenuItem;
    Beginorcommittransaction1: TMenuItem;
    Rollbacktransaction1: TMenuItem;
    ToolButton8: TToolButton;
    ToolButton9: TToolButton;
    ToolButton10: TToolButton;
    acReadCommited: TAction;
    acRepeatableRead: TAction;
    N4: TMenuItem;
    Readcommited1: TMenuItem;
    Repeatablereads1: TMenuItem;
    procedure acDisconnectExecute(Sender: TObject);
    procedure acConnectExecute(Sender: TObject);
    procedure acExitExecute(Sender: TObject);
    procedure ConnectedRequired(Sender: TObject);
    procedure acNewPlanTableExecute(Sender: TObject);
    procedure acSelectPlanTableExecute(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure acAnalyseUpdate(Sender: TObject);
    procedure StatusBar1Hint(Sender: TObject);
    procedure acExecuteExecute(Sender: TObject);
    procedure acAnalyseExecute(Sender: TObject);
    procedure acAboutExecute(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure acPreviousUpdate(Sender: TObject);
    procedure acNextUpdate(Sender: TObject);
    procedure acPreviousExecute(Sender: TObject);
    procedure acNextExecute(Sender: TObject);
    procedure acStartUpdate(Sender: TObject);
    procedure acRollbackExecute(Sender: TObject);
    procedure acRollbackUpdate(Sender: TObject);
    procedure acStartExecute(Sender: TObject);
    procedure IsolationUpdate(Sender: TObject);
    procedure IsolationExecute(Sender: TObject);
  private
    FQueries: TStringList;
    FQueryIndex: Integer;
    procedure AddQuery;
  public
  end;

var
  wndMain: TwndMain;

implementation

uses Data, AskConnect, AskNewPlan, SelectPlanTable, About;

{$R *.DFM}

procedure TwndMain.acDisconnectExecute(Sender: TObject);
begin
  modData.Disconnect;
  StatusBar1.Panels[0].Text := '';
  StatusBar1.Panels[1].Text := '';
end;

procedure TwndMain.acConnectExecute(Sender: TObject);
begin
  try
    with TwndAskConnect.Create(nil) do
    try
      if ShowModal = mrOk then
        modData.Connect(Edit1.Text, Edit2.Text, Edit3.Text);
    finally
      Free;
    end;
    StatusBar1.Panels[0].Text := modData.OraDB.Params.Values['SERVER NAME'];
    StatusBar1.Panels[1].Text := '';
  except
    StatusBar1.Panels[0].Text := '';
    StatusBar1.Panels[1].Text := '';
    raise;
  end;
end;

procedure TwndMain.acExitExecute(Sender: TObject);
begin
  Close;
end;

procedure TwndMain.ConnectedRequired(Sender: TObject);
begin
  TAction(Sender).Enabled := modData.Connected;
end;

procedure TwndMain.acNewPlanTableExecute(Sender: TObject);
begin
  try
    with TwndAskNewPlan.Create(nil) do
    try
      if ShowModal = mrOk then
        modData.NewPlanTable(Edit1.Text);
    finally
      Free;
    end;
  finally
    StatusBar1.Panels[1].Text := modData.PlanTable;
  end;
end;

procedure TwndMain.acSelectPlanTableExecute(Sender: TObject);
begin
  try
    with TwndSelectPlanTable.Create(nil) do
    try
      if ShowModal = mrOk then
        modData.PlanTable := ListBox1.Items[ListBox1.ItemIndex];
    finally
      Free;
    end;
  finally
    StatusBar1.Panels[1].Text := modData.PlanTable;
  end;
end;

procedure TwndMain.FormCreate(Sender: TObject);
begin
  Notebook1.PageIndex := 2;
  FQueries := TStringList.Create;
end;

procedure TwndMain.acAnalyseUpdate(Sender: TObject);
begin
  TAction(Sender).Enabled := modData.Connected and (modData.PlanTable <> '');
end;

procedure TwndMain.StatusBar1Hint(Sender: TObject);
begin
  StatusBar1.Panels[2].Text := Application.Hint;
end;

procedure TwndMain.acExecuteExecute(Sender: TObject);
begin
  Notebook1.PageIndex := 2;
  if modData.ExecuteQuery(RichEdit1.Lines) then
    Notebook1.PageIndex := 1;
  AddQuery;
end;

procedure TwndMain.acAnalyseExecute(Sender: TObject);
var
  Id, ParentId, I: Integer;
  Operation: string;
  OldNode: TTreeNode;
begin
  Notebook1.PageIndex := 2;
  modData.AnalyseQuery(RichEdit1.Lines);
  TreeView1.Items.BeginUpdate;
  ListView1.Items.BeginUpdate;
  try
    TreeView1.Items.Clear;
    ListView1.Items.Clear;
    while not modData.Query2.Eof do
    begin
      Id := modData.Query2.FieldByName('ID').AsInteger;
      ParentId := modData.Query2.FieldByName('PARENT_ID').AsInteger;
      Operation := modData.Query2.FieldByName('OPERATION').AsString;
      OldNode := nil;
      if modData.Query2['LEVEL'] > 1 then
        for I := 0 to TreeView1.Items.Count - 1 do
          if TreeView1.Items[I].Data = Pointer(ParentId) then
          begin
            OldNode := TreeView1.Items[I];
            Break;
          end;
      with TreeView1.Items.AddChild(OldNode, Operation) do
        Data := Pointer(Id);
      with ListView1.Items.Add do
      begin
        Caption := Operation;
        SubItems.Add(VarToStr(modData.Query2['OBJECT_NAME']));
        SubItems.Add(VarToStr(modData.Query2['OPTIONS']));
        with modData.Query2.FieldByName('POSITION') do
          if not IsNull then
            SubItems.Add(modData.Query2.FieldByName('POSITION').AsString);
      end;
      modData.Query2.Next;
    end;
    TreeView1.FullExpand;
  finally
    ListView1.Items.EndUpdate;
    TreeView1.Items.EndUpdate;
  end;
  Notebook1.PageIndex := 0;
  AddQuery;
end;

procedure TwndMain.acAboutExecute(Sender: TObject);
begin
  with TwndAbout.Create(nil) do
  try
    ShowModal;
  finally
    Free;
  end;
end;

procedure TwndMain.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  FQueries.Free;
end;

procedure TwndMain.AddQuery;
begin
  FQueries.Add(RichEdit1.Lines.Text);
  FQueryIndex := FQueries.Count;
  RichEdit1.Clear;
end;

procedure TwndMain.acPreviousUpdate(Sender: TObject);
begin
  TAction(Sender).Enabled := (FQueries.Count > 0) and (FQueryIndex > 0);
end;

procedure TwndMain.acNextUpdate(Sender: TObject);
begin
  TAction(Sender).Enabled := (FQueries.Count > 0) and (FQueryIndex < FQueries.Count);
end;

procedure TwndMain.acPreviousExecute(Sender: TObject);
begin
  Dec(FQueryIndex);
  RichEdit1.Lines.Text := FQueries[FQueryIndex];
end;

procedure TwndMain.acNextExecute(Sender: TObject);
begin
  Inc(FQueryIndex);
  if FQueryIndex = FQueries.Count then
    RichEdit1.Clear
  else
    RichEdit1.Lines.Text := FQueries[FQueryIndex];
end;

procedure TwndMain.acStartUpdate(Sender: TObject);
begin
  acStart.Enabled := modData.Connected;
  if acStart.Enabled then
    acStart.Checked := modData.OraDB.InTransaction
  else
    acStart.Checked := False;
end;

procedure TwndMain.acRollbackExecute(Sender: TObject);
begin
  modData.OraDB.Rollback;
end;

procedure TwndMain.acRollbackUpdate(Sender: TObject);
begin
  acRollback.Enabled := modData.Connected and modData.OraDB.InTransaction;
end;

procedure TwndMain.acStartExecute(Sender: TObject);
begin
  with modData.OraDB do
    if InTransaction then
      Commit
    else
      StartTransaction;
end;

procedure TwndMain.IsolationUpdate(Sender: TObject);
begin
  with modData.OraDB do
  begin
    TAction(Sender).Enabled := Connected;
    TAction(Sender).Checked := TAction(Sender).Tag = Ord(TransIsolation);
  end;
end;

procedure TwndMain.IsolationExecute(Sender: TObject);
begin
  modData.OraDB.TransIsolation := TTransIsolation(TAction(Sender).Tag);
end;

end.
